from copy import copy, deepcopy
import logging
logging.basicConfig()

import fuse
import rpclib 

# local-only, currently
class StorageClient(object):
	def __init__(self):
		self.host = '127.0.0.1'
		self.port = 11111
		self.cache = {}

	def _rpc_call(self, method, kwargs):
		with rpclib.client_connect(self.host, self.port) as c:
			return c.call(method, **kwargs)

	def read(self, addr):
		if addr not in self.cache:
			print 'read', addr
			self.cache[addr] = self._rpc_call('read', {'addr':addr})
		return self.cache[addr]
	
	def write(self, block):
		print 'write', block.addr
		success = self._rpc_call('write', {'block':block})
		if success:
			self.cache[block.addr] = block
		return success

	def delete(self, addr):
		del self.cache[addr]
		return self._rpc_call('delete', {'addr': addr})

	def get_used_space(self):
		return self._rpc_call('get_used_space', {})

	def get_free_space(self):
		return self._rpc_call('get_free_space', {})
